#include "windows.h"

static LPTOP_LEVEL_EXCEPTION_FILTER old_filter;

DWORD WINAPI my_filter_callback(LPVOID lpThreadParameter) {
	return old_filter(static_cast<_EXCEPTION_POINTERS*>(lpThreadParameter));
}

static LONG WINAPI my_filter(struct _EXCEPTION_POINTERS *ExceptionInfo) {
	if (old_filter) {
		if (ExceptionInfo->ExceptionRecord->ExceptionCode == EXCEPTION_STACK_OVERFLOW) {
			const size_t MB = 1024 * 1024 * 1;
			HANDLE thread = CreateThread(nullptr, 1*MB, my_filter_callback, ExceptionInfo, 0, nullptr);
			WaitForSingleObject(thread, INFINITE);
			LONG result = 0;
			GetExitCodeThread(thread, reinterpret_cast<DWORD*>(&result));
			CloseHandle(thread);
			return result;

		}
		else {
			return old_filter(ExceptionInfo);
		}
	}
	else {
		return UnhandledExceptionFilter(ExceptionInfo);
	}
}

static bool initialize() {
	old_filter = SetUnhandledExceptionFilter(my_filter);
	return true;
}

static bool finalize() {
	return true;
}

extern "C"
BOOL APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpvReserved) {
    switch (fdwReason) {
        case DLL_PROCESS_ATTACH:
            DisableThreadLibraryCalls(hModule);
			return initialize();
		case DLL_PROCESS_DETACH:
			return finalize();
    }

    return true;
}
